"use strict";

exports.__esModule = true;
var setDataDefConfig = require("./setDataDefConfig");
function validateAxis(dataDef, oriAxis) {
    if (oriAxis === true) {
        return true;
    }
    var axis = Array.isArray(oriAxis) ? oriAxis : [oriAxis];
    var seriesKey = [];
    var newAxis = [];
    for (var _i = 0, _a = dataDef.column; _i < _a.length; _i++) {
        var citem = _a[_i];
        seriesKey.push(citem);
    }
    for (var _b = 0, _c = dataDef.row; _b < _c.length; _b++) {
        var ritem = _c[_b];
        seriesKey.push(ritem);
    }
    for (var _d = 0, axis_1 = axis; _d < axis_1.length; _d++) {
        var item = axis_1[_d];
        if (item && item.dataKey && seriesKey.indexOf(item.dataKey) >= 0) {
            newAxis.push(item);
        }
    }
    return newAxis;
}
function validateSeries(dataDef, oriSeries) {
    if (!oriSeries) {
        throw new Error('please set at least 1 series');
    }
    var series = Array.isArray(oriSeries) ? oriSeries : [oriSeries];
    var colsKey = dataDef.column;
    var rowsKey = dataDef.row;
    for (var _i = 0, series_1 = series; _i < series_1.length; _i++) {
        var item = series_1[_i];
        if (!item.position && dataDef.column && dataDef.row) {
            if (item.quickType === 'pie') {
                item.position = "" + dataDef.row[0];
            } else {
                item.position = dataDef.column[0] + "*" + dataDef.row[0];
            }
        }
        var pos = void 0;
        if (Array.isArray(item.position)) {
            pos = item.position;
        } else {
            pos = item.position.split('*');
        }
        if (pos.length === 2) {
            if (colsKey.indexOf(pos[0]) < 0 || rowsKey.indexOf(pos[1]) < 0) {
                throw new Error('please set correct position in series');
            }
        } else if (pos.length === 1) {
            if (rowsKey.indexOf(pos[0]) < 0) {
                throw new Error('please set correct position in series');
            }
        }
    }
    return series;
}
exports.checkChartConfig = function (config) {
    var chart = config.chart;
    if (!chart || !chart.height) {
        throw new Error('please set correct chart option');
    }
    return config;
};
exports.checkViewConfig = function (config) {
    config.dataDef = setDataDefConfig.process(config);
    if (config.views && config.views.length) {
        config.viewId = '00000';
    }
    if (config.axis) {
        config.axis = validateAxis(config.dataDef, config.axis);
    } else {
        config.axis = false;
    }
    if (config.guide) {
        var guide = config.guide;
        config.guide = Array.isArray(guide) ? guide : [guide];
    }
    config.series = validateSeries(config.dataDef, config.series);
    return config;
};
//# sourceMappingURL=validateConfig.js.map